Description

with the introduction of the api, the query interface is no longer needed.

Related issues:

Related to Hammer CLI - Feature #945: foreman CLI Closed 05/26/2011

Has duplicate Foreman - Refactor #818: refactor example scripts to use forema... Closed 04/01/2011

Associated revisions

Revision 17637a75 - 02/19/2012 09:04 AM - Ohad Levy

fixes #1173 - remove legacy query interface

Revision 5ff42807 - 02/19/2012 01:24 PM - Ohad Levy

refs #1173 - remove unneed files

Revision 4edaa78b - 02/20/2012 02:43 AM - Ohad Levy

refs #1173 - another leftover

History

#1 - 10/09/2011 08:46 PM - Brian Gupta

- Assignee set to Brian Gupta

Ohad,

I want to make sure what needs to be done here. Are we looking at refactoring ssh_using_foreman, or foreman.rb (or both) to work with the API? Or

maybe you are thinking we can just get rid of both since foremancli now can do everything it can?

Thanks,

Brian

#2 - 10/10/2011 07:53 PM - Brian Gupta

Ohad, looking at the API docs, I'm not sure if there is a way to query the API for a list of hosts with certain puppetclasses 

http://theforeman.org/projects/foreman/wiki/API Am I missing something?

The other piece where you query for a list of hosts that match certain facts, seems to be implemented in the REST API as "/facts/<factname>/values"

However the ssh_using_foreman scriptallows ONE OR MORE facts in the query:     "-f, --facts fact=x,fact=y..      one or more facts to filter the host

list" I am not aware of how to do this in the API either.

Thoughts??

#3 - 10/10/2011 07:58 PM - Brian Gupta

Just realized that you probably have this functionality in the search API, I just can't find documentation for it.

#4 - 10/10/2011 08:20 PM - Brian Gupta
I ended up using the GUI to generate a query, and tailed the production log to find how the searches are encoded, and found this as an example: 

https://foreman/hosts?search=+class++%3D++base%3A%3Amonitor-only++or++class++%3D++apache2%3A%3Agb

You don't have this more cleanly documented somewhere or a code example, do you?

#5 - 10/10/2011 09:01 PM - Brian Gupta

And facts might be a problem as the GUI returned this when I started with Facts =":

Field 'facts' not recognized for searching!

#6 - 10/10/2011 09:04 PM - Brian Gupta

Ah it's facts.fact = blah. Testing API now..

#7 - 10/10/2011 09:28 PM - Brian Gupta

- % Done changed from 0 to 10

There may be some weird behavior with "OR" that I think is a bug, but "AND" seems to be working. (For future reference the search I did that

triggered the bug was facts.hostname=redmine or facts.hostname=dev1, I will be doing further testing and open a bug report.)

#8 - 10/10/2011 10:00 PM - Brian Gupta

Ohad,

Nevermind about the "OR" issue. It was already discovered and closed. One question about how ssh_using_foreman is supposed to work filtering

multiple puppetclasses or facts, is it an AND or an OR?

Thanks,

Brian

#9 - 10/10/2011 10:06 PM - Brian Gupta

Note to self /usr/bin/ruby is hardcoded, should replace with /usr/bin/env ruby. Also, gem net-ssh-multi is required.. thinking that might not be in the list

of required gems for foreman.

#10 - 10/10/2011 10:10 PM - Brian Gupta

Reminder to update http://theforeman.org/projects/foreman/wiki/Query_Interface once we make these changes.

#11 - 02/19/2012 09:03 AM - Ohad Levy

- Category set to 19

- Assignee changed from Brian Gupta to Ohad Levy

- Target version set to 1.0

#12 - 02/19/2012 09:42 AM - Ohad Levy

- Status changed from New to Closed

- % Done changed from 10 to 100

Applied in changeset 17637a7526a033678ccad9fc65748525e44de13d.

#13 - 10/16/2018 01:33 PM - Tomer Brisker

- Category changed from 19 to Search
